//+------------------------------------------------------------------+
//|                                                         DCE.mq4  |
//|                                               PriceMasterPro.Com |
//|                                    http://www.pricemasterpro.com |
//+------------------------------------------------------------------+
#property copyright "2011(c) - PriceMasterPro.Com"
#property link      "http://www.pricemasterpro.com/"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red

extern int Period1 = 44;
extern int Period2 = 22;
extern int Period3 = 66;
extern int Period4 = 33;
extern int Period5 = 29;
extern int Period6 = 14;
extern int Price   = PRICE_CLOSE;

double Map[];
double prices[];
int    maxPeriod;
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,Map);
   SetIndexBuffer(1,prices);
   IndicatorShortName("DCE"+Period1+","+Period2);
      maxPeriod = MathMax(Period1,Period2);
      maxPeriod = MathMax(Period3,maxPeriod);
      maxPeriod = MathMax(Period4,maxPeriod);
      maxPeriod = MathMax(Period5,maxPeriod);
      maxPeriod = MathMax(Period6,maxPeriod);
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(MathMax(Bars-counted_bars,maxPeriod),Bars-1);
         
   //
   //
   //
   //
   //
    
   for (i=limit; i>=0; i--) prices[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
   for (i=limit; i>=0; i--)
   {
        Map[i] = icTma(Period2,i)-icTma(Period1,i)+icTma(Period4,i)-icTma(Period3,i)+icTma(Period6,i)-icTma(Period5,i);
   }   
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

double icTma(int period, int i)
{
   int j,k;
   double sum  = (period+1)*prices[i];
   double sumw = (period+1);

      //
      //
      //
      //
      //
      
      for(j=1, k=period; j<period; j++,k--)
      {
         sum  += prices[i+j]*k;
         sumw += k;
         if (j<=i)
         {
               sum  += prices[i-j]*k;
               sumw += k;
         }
      }
   return(sum/sumw);
}